xfstests: remove 285.full and 286.full
[xfstests-dev.git] / 247
1 #! /bin/bash
2 # FS QA Test No. 247
3 #
4 # Test for race between direct I/O and mmap
5 #
6 #-----------------------------------------------------------------------
7 # Copyright (c) 2010 Red Hat, Inc.  All Rights Reserved.
8 #
9 # This program is free software; you can redistribute it and/or
10 # modify it under the terms of the GNU General Public License as
11 # published by the Free Software Foundation.
12 #
13 # This program is distributed in the hope that it would be useful,
14 # but WITHOUT ANY WARRANTY; without even the implied warranty of
15 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
16 # GNU General Public License for more details.
17 #
18 # You should have received a copy of the GNU General Public License
19 # along with this program; if not, write the Free Software Foundation,
20 # Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
21 #-----------------------------------------------------------------------
22 #
23
24 seq=`basename $0`
25 echo "QA output created by $seq"
26
27 here=`pwd`
28 tmp=/tmp/$$
29 status=1        # failure is the default!
30 trap "_cleanup; exit \$status" 0 1 2 3 7 15
31
32 _cleanup()
33 {
34     cd /
35     rm -f $tmp.* $testfile
36     wait
37 }
38
39 # get standard environment, filters and checks
40 . ./common.rc
41 . ./common.filter
42
43 # real QA test starts here
44
45 # Modify as appropriate.
46 _supported_fs generic
47 _supported_os Linux
48
49 testfile=$TEST_DIR/$seq.$$
50
51 loops=500
52 iosize=1048576
53
54 # Initialise file
55 dd if=/dev/zero of=$testfile bs=$iosize count=$loops &> /dev/null
56 [ $? -ne 0 ] && exit
57 sync
58         
59 # Direct I/O overwriter
60 dd if=/dev/zero of=$testfile oflag=direct bs=$iosize count=$loops conv=notrunc &> /dev/null &
61 [ $? -ne 0 ] && exit
62
63 # Mmap writer
64 start=`expr $loops - 1`
65 for i in `seq $start -1 0`
66 do
67         offset=`expr $i \* $iosize`
68         $XFS_IO_PROG -F -f -c "mmap -w $offset $iosize" -c "mwrite $offset $iosize" $testfile
69         [ $? -ne 0 ] && exit
70 done
71
72 wait
73
74 echo "Silence is golden."
75
76 # success, all done
77 status=0
78 exit